#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3200four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 3200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3200four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four32004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four32004xi = {
        1 :  '1002x-1179y2800z',
        2 :  '1003x-479y3000z',
        3 :  '1054x-437y2989z',
        4 :  '1064x-1750y2458z',
        5 :  '1082x-1145y2785z',
        6 :  '1104x-391y2977z',
        7 :  '1128x-2940y564z',
        8 :  '1151x-341y2965z',
        9 :  '1160x-1106y2769z',
        10 :  '1168x-1712y2437z',
        11 :  '1181x-2199y2002z',
        12 :  '1196x-287y2953z',
        13 :  '1237x-1062y2753z',
        14 :  '1239x-230y2941z',
        15 :  '1270x-1668y2416z',
        16 :  '1278x-168y2928z',
        17 :  '1283x-2882y532z',
        18 :  '1305x-2151y1976z',
        19 :  '1313x-1012y2736z',
        20 :  '1314x-104y2915z',
        21 :  '1347x-35y2902z',
        22 :  '1372x-1618y2395z',
        23 :  '1387x-957y2719z',
        24 :  '1427x-2096y1951z',
        25 :  '1434x-2816y500z',
        26 :  '1458x-898y2702z',
        27 :  '1471x-1561y2374z',
        28 :  '1527x-833y2685z',
        29 :  '1546x-2034y1926z',
        30 :  '1568x-1498y2352z',
        31 :  '1582x-2741y469z',
        32 :  '1592x-764y2668z',
        33 :  '162x-3106y751z',
        34 :  '1655x-689y2650z',
        35 :  '1662x-1429y2330z',
        36 :  '1663x-1964y1900z',
        37 :  '1713x-611y2632z',
        38 :  '1726x-2658y437z',
        39 :  '1753x-1355y2308z',
        40 :  '1768x-528y2613z',
        41 :  '1776x-1888y1874z',
        42 :  '1819x-441y2595z',
        43 :  '1840x-1274y2286z',
        44 :  '1865x-2567y405z',
        45 :  '1865x-350y2576z',
        46 :  '1886x-1806y1848z',
        47 :  '1906x-255y2557z',
        48 :  '190x-145y3191z',
        49 :  '1924x-1188y2263z',
        50 :  '1942x-157y2538z',
        51 :  '1973x-56y2518z',
        52 :  '1992x-1717y1822z',
        53 :  '2000x-2469y374z',
        54 :  '2003x-1097y2241z',
        55 :  '2078x-1000y2218z',
        56 :  '2093x-1621y1796z',
        57 :  '2128x-2364y342z',
        58 :  '2147x-898y2195z',
        59 :  '217x-613y3133z',
        60 :  '2190x-1519y1769z',
        61 :  '2212x-792y2171z',
        62 :  '223x-153y3188z',
        63 :  '2252x-2252y310z',
        64 :  '2271x-681y2148z',
        65 :  '2282x-1412y1742z',
        66 :  '2325x-566y2124z',
        67 :  '2368x-1299y1715z',
        68 :  '2369x-2133y278z',
        69 :  '2372x-448y2100z',
        70 :  '2413x-326y2076z',
        71 :  '2447x-201y2051z',
        72 :  '2448x-1180y1688z',
        73 :  '2475x-73y2026z',
        74 :  '2479x-2007y246z',
        75 :  '2522x-1057y1661z',
        76 :  '2583x-1876y214z',
        77 :  '258x-157y3185z',
        78 :  '260x-630y3126z',
        79 :  '2670x-958y1685z',
        80 :  '2679x-1739y182z',
        81 :  '2768x-1598y150z',
        82 :  '2849x-1451y119z',
        83 :  '2922x-1301y87z',
        84 :  '294x-159y3182z',
        85 :  '2987x-1146y55z',
        86 :  '3043x-988y23z',
        87 :  '306x-644y3119z',
        88 :  '325x-3100y720z',
        89 :  '331x-157y3178z',
        90 :  '355x-654y3112z',
        91 :  '368x-151y3175z',
        92 :  '405x-142y3170z',
        93 :  '405x-661y3104z',
        94 :  '443x-130y3166z',
        95 :  '456x-665y3096z',
        96 :  '480x-114y3161z',
        97 :  '488x-3086y689z',
        98 :  '509x-664y3088z',
        99 :  '516x-94y3156z',
        100 :  '524x-1273y2888z',
        101 :  '552x-71y3151z',
        102 :  '563x-660y3079z',
        103 :  '586x-45y3145z',
        104 :  '602x-1270y2874z',
        105 :  '618x-652y3071z',
        106 :  '619x-15y3139z',
        107 :  '651x-3063y658z',
        108 :  '674x-640y3061z',
        109 :  '681x-1262y2860z',
        110 :  '730x-624y3052z',
        111 :  '761x-1249y2845z',
        112 :  '785x-603y3042z',
        113 :  '812x-3031y626z',
        114 :  '841x-1231y2831z',
        115 :  '841x-578y3032z',
        116 :  '854x-1807y2498z',
        117 :  '896x-549y3022z',
        118 :  '922x-1207y2816z',
        119 :  '950x-516y3011z',
        120 :  '959x-1782y2478z',
        121 :  '971x-2990y595z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3200four4xi" usage = "target function for charge32004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3200four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3200FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3200FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3200FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3200FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3200FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four32004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3200FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3200FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3200FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four32004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four32004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3200FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3200FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3200FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3200four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    